Package org.zkoss.stateless.sul

## Interface IFrozen<I extends IAnyGroup>

- All Superinterfaces:
    `IAnyGroup<IFrozen<I>>`, `IChildable<IFrozen<I>,​I>`, `IComponent<IFrozen<I>>`, `IHtmlBasedComponent<IFrozen<I>>`, `IMeshComposite<IFrozen<I>>`, `IXulElement<IFrozen<I>>`

      public interface IFrozen<I extends IAnyGroup>
      extends IXulElement<IFrozen<I>>, IChildable<IFrozen<I>,​I>, IMeshComposite<IFrozen<I>>, IAnyGroup<IFrozen<I>>

  Immutable `Frozen` component
  Author:
    jumperchen
  See Also:
    `Frozen`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IFrozen.Builder<I extends IAnyGroup>` | Builds instances of type `IFrozen`.
    `static class` | `IFrozen.Updater` | Builds an updater of type `IFrozen` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IFrozen<IAnyGroup>` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default int` | `getColumns()` | Returns the number of columns to freeze.
    `default int` | `getRightColumns()` | Returns the number of right columns to freeze.
    `default int` | `getStart()` | Returns the start position of the scrollbar.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default boolean` | `isSmooth()` | Returns the frozen is smooth or not.
    `static <I extends IAnyGroup> IFrozen<I>` | `ofColumns​(int columns)` | Return the instance with the given columns
    `static <I extends IAnyGroup> IFrozen<I>` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `IFrozen<I>` | `withColumns​(int columns)` | Returns a copy of `this` immutable component with the specified `columns`.
    `IFrozen<I>` | `withRightColumns​(int rightColumns)` | Returns a copy of `this` immutable component with the specified `rightColumns`.
    `IFrozen<I>` | `withSmooth​(boolean smooth)` | Returns a copy of `this` immutable component with the specified `smooth`.
    `IFrozen<I>` | `withStart​(int start)` | Returns a copy of `this` immutable component with the specified `start`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IFrozen<IAnyGroup> DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.mesh.Frozen"`

      Specified by:
        `getWidgetClass` in interface `IComponent<I extends IAnyGroup>`

    - #### getColumns

          default int getColumns()

      Returns the number of columns to freeze.

      Default: `0`

    - #### withColumns

          IFrozen<I> withColumns​(int columns)

      Returns a copy of `this` immutable component with the specified `columns`.

      Sets the number of columns to freeze.

      Parameters:
        `columns` - The number of columns to freeze.

        Default: `0`.

      Returns:
        A modified copy of the `this` object

    - #### getStart

          default int getStart()

      Returns the start position of the scrollbar.

      Default: `0`

    - #### withStart

          IFrozen<I> withStart​(int start)

      Returns a copy of `this` immutable component with the specified `start`.

      Sets the start position of the scrollbar.

      Parameters:
        `start` - The start position of the scrollbar.

        Default: `0`.

      Returns:
        A modified copy of the `this` object

    - #### getRightColumns

          default int getRightColumns()

      Returns the number of right columns to freeze. Note: only useful when using smooth Frozen and browsers that supports CSS position: sticky.

      Default: `0`

    - #### withRightColumns

          IFrozen<I> withRightColumns​(int rightColumns)

      Returns a copy of `this` immutable component with the specified `rightColumns`.

      Sets the number of right columns to freeze.

      Parameters:
        `rightColumns` - The number of right columns to freeze.

        Default: `0`.

      Returns:
        A modified copy of the `this` object

    - #### isSmooth

          default boolean isSmooth()

      Returns the frozen is smooth or not.

      Default: `true`

    - #### withSmooth

          IFrozen<I> withSmooth​(boolean smooth)

      Returns a copy of `this` immutable component with the specified `smooth`.

      Sets the frozen is smooth or not.

      Parameters:
        `smooth` - The number of right columns to freeze.

        Default: `true`.

      Returns:
        A modified copy of the `this` object

    - #### ofColumns

          static <I extends IAnyGroup> IFrozen<I> ofColumns​(int columns)

      Return the instance with the given columns
      Parameters:
        `columns` - The number of columns to freeze.(from left to right)

    - #### ofId

          static <I extends IAnyGroup> IFrozen<I> ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component.